## ros-galactic-controller-manager 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(controller_manager)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_core REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(controller_interface REQUIRED)
find_package(controller_manager_msgs REQUIRED)
find_package(hardware_interface REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp REQUIRED)

add_library(controller_manager SHARED
  src/controller_manager.cpp
  src/realtime.cpp
)
target_include_directories(controller_manager PRIVATE include)
ament_target_dependencies(controller_manager
  ament_index_cpp
  controller_interface
  controller_manager_msgs
  hardware_interface
  pluginlib
  rclcpp
)
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(controller_manager PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")

add_executable(ros2_control_node src/ros2_control_node.cpp)
target_include_directories(ros2_control_node PRIVATE include)
target_link_libraries(ros2_control_node controller_manager)
ament_target_dependencies(ros2_control_node
  controller_interface
  hardware_interface
  rclcpp
)

install(TARGETS controller_manager
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
)

install(TARGETS ros2_control_node
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/
  DESTINATION include
)

install(PROGRAMS
  scripts/spawner
  scripts/spawner.py  # Deprecated
  scripts/unspawner
  scripts/unspawner.py  # Deprecated
  DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(ros2_control_test_assets REQUIRED)

  list(APPEND AMENT_LINT_AUTO_EXCLUDE
    ament_cmake_uncrustify
    ament_cmake_cpplint
  )
  ament_lint_auto_find_test_dependencies()

  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()

  add_library(test_controller SHARED test/test_controller/test_controller.cpp)
  target_include_directories(test_controller PRIVATE include)
  target_link_libraries(test_controller controller_manager)
  target_compile_definitions(test_controller PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller/test_controller.xml)
  install(TARGETS test_controller
    DESTINATION lib
  )

  add_library(test_controller_failed_init SHARED test/test_controller_failed_init/test_controller_failed_init.cpp)
  target_include_directories(test_controller_failed_init PRIVATE include)
  target_link_libraries(test_controller_failed_init controller_manager)
  target_compile_definitions(test_controller_failed_init PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller_failed_init/test_controller_failed_init.xml)
  install(TARGETS test_controller_failed_init
    DESTINATION lib
  )

  ament_add_gmock(
    test_controller_manager
    test/test_controller_manager.cpp
  )
  target_include_directories(test_controller_manager PRIVATE include)
  target_link_libraries(test_controller_manager controller_manager test_controller)
  ament_target_dependencies(test_controller_manager ros2_control_test_assets)

  ament_add_gmock(
    test_load_controller
    test/test_load_controller.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_load_controller PRIVATE include)
  target_link_libraries(test_load_controller controller_manager test_controller test_controller_failed_init)
  ament_target_dependencies(test_load_controller ros2_control_test_assets)

  ament_add_gmock(
    test_controller_manager_srvs
    test/test_controller_manager_srvs.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_controller_manager_srvs PRIVATE include)
  target_link_libraries(test_controller_manager_srvs controller_manager test_controller)
  ament_target_dependencies(
    test_controller_manager_srvs
    controller_manager_msgs
    ros2_control_test_assets
  )

  add_library(test_controller_with_interfaces SHARED test/test_controller_with_interfaces/test_controller_with_interfaces.cpp)
  target_include_directories(test_controller_with_interfaces PRIVATE include)
  target_link_libraries(test_controller_with_interfaces controller_manager)
  target_compile_definitions(test_controller_with_interfaces PRIVATE "CONTROLLER_MANAGER_BUILDING_DLL")
  pluginlib_export_plugin_description_file(
    controller_interface test/test_controller_with_interfaces/test_controller_with_interfaces.xml)
  install(TARGETS test_controller_with_interfaces
    DESTINATION lib
  )

  ament_add_gmock(
    test_release_interfaces
    test/test_release_interfaces.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}_$<CONFIG>
  )
  target_include_directories(test_release_interfaces PRIVATE include)
  target_link_libraries(test_release_interfaces controller_manager test_controller_with_interfaces)
  ament_target_dependencies(test_release_interfaces ros2_control_test_assets)

  ament_add_gmock(
    test_spawner_unspawner
    test/test_spawner_unspawner.cpp
  )
  target_include_directories(test_spawner_unspawner PRIVATE include)
  target_link_libraries(test_spawner_unspawner controller_manager test_controller)
  ament_target_dependencies(test_spawner_unspawner ros2_control_test_assets)
endif()

# Install Python modules
ament_python_install_package(${PROJECT_NAME})

ament_export_libraries(
  controller_manager
)
ament_export_include_directories(
  include
)
ament_export_dependencies(
  controller_interface
  controller_manager_msgs
  hardware_interface
  pluginlib
  rclcpp
)
ament_package()

=== debian/changelog ===
ros-galactic-controller-manager (1.6.0-1focal) focal; urgency=high

  * Fixes of issue with seg-fault when checking interfaces on unconfigured controllers. (#580 <https://github.com/ros-controls/ros2_control/issues/580>) (#795 <https://github.com/ros-controls/ros2_control/issues/795>)
  * [ros2_control_node] Automatically detect if RT kernel is used and opportunistically enable SCHED_FIFO (#748 <https://github.com/ros-controls/ros2_control/issues/748>) (#768 <https://github.com/ros-controls/ros2_control/issues/768>)
  * Contributors: Denis Štogl, Tyler Weaver

 -- karsten <karsten@osrfoundation.org>  Tue, 02 Aug 2022 23:00:00 -0000

ros-galactic-controller-manager (1.5.1-1focal) focal; urgency=high



 -- karsten <karsten@osrfoundation.org>  Mon, 30 May 2022 23:00:00 -0000

ros-galactic-controller-manager (1.5.0-1focal) focal; urgency=high

  * Spawner waits for services (#683 <https://github.com/ros-controls/ros2_control/issues/683>) (#697 <https://github.com/ros-controls/ros2_control/issues/697>)
  * Contributors: Tyler Weaver

 -- karsten <karsten@osrfoundation.org>  Thu, 28 Apr 2022 23:00:00 -0000

ros-galactic-controller-manager (1.4.0-1focal) focal; urgency=high

  * added a fixed control period to loop (#647 <https://github.com/ros-controls/ros2_control/issues/647>) (#650 <https://github.com/ros-controls/ros2_control/issues/650>)
  * Contributors: Jack Center

 -- karsten <karsten@osrfoundation.org>  Fri, 18 Feb 2022 00:00:00 -0000

ros-galactic-controller-manager (1.3.0-1focal) focal; urgency=high

  * fix get_update_rate visibility in windows (#586 <https://github.com/ros-controls/ros2_control/issues/586>) (#588 <https://github.com/ros-controls/ros2_control/issues/588>)
    (cherry picked from commit 3f4a55bd898d5ae16fbefb6b19822dce0dbeba2a)
    Co-authored-by: Melvin Wang <mailto:melvin.mc.wang@gmail.com>
  * Make output of not available controller nicer and make it informational. (#577 <https://github.com/ros-controls/ros2_control/issues/577>)
  * Contributors: Denis Štogl, mergify[bot]

 -- karsten <karsten@osrfoundation.org>  Tue, 21 Dec 2021 00:00:00 -0000

ros-galactic-controller-manager (1.2.0-1focal) focal; urgency=high



 -- karsten <karsten@osrfoundation.org>  Fri, 05 Nov 2021 00:00:00 -0000

ros-galactic-controller-manager (1.1.0-1focal) focal; urgency=high

  * feat: add colored output into spawner.py (#560 <https://github.com/ros-controls/ros2_control/issues/560>)
  * Added timeout argument for service_caller timeout (#552 <https://github.com/ros-controls/ros2_control/issues/552>)
  * controller_manager: Use command_interface_configuration for the claimed interfaces when calling list_controllers (#544 <https://github.com/ros-controls/ros2_control/issues/544>)
  * Clean up test_load_controller (#532 <https://github.com/ros-controls/ros2_control/issues/532>)
  * Contributors: Jack Center, Jafar Abdi, Michael, Nour Saeed

 -- karsten <karsten@osrfoundation.org>  Sun, 24 Oct 2021 23:00:00 -0000

ros-galactic-controller-manager (1.0.0-1focal) focal; urgency=high

  * Use ControllerManager node clock for control loop timepoints (#542 <https://github.com/ros-controls/ros2_control/issues/542>)
  * Per controller update rate(#513 <https://github.com/ros-controls/ros2_control/issues/513>)
  * added dt to controller interface and controller manager #438 <https://github.com/ros-controls/ros2_control/issues/438> (#520 <https://github.com/ros-controls/ros2_control/issues/520>)
  * Update nomenclature in CM for better code and output understanding (#517 <https://github.com/ros-controls/ros2_control/issues/517>)
  * Methods controlling the lifecycle of controllers all have on_ prefix
  * Controller Manager should not crash when trying to start finalized or unconfigured controller (#461 <https://github.com/ros-controls/ros2_control/issues/461>)
  * Fix deprecation warning from rclcpp::Duration (#511 <https://github.com/ros-controls/ros2_control/issues/511>)
  * Remove BOOST compiler definitions for pluginlib from CMakeLists (#514 <https://github.com/ros-controls/ros2_control/issues/514>)
  * Do not manually set C++ version to 14 (#516 <https://github.com/ros-controls/ros2_control/issues/516>)
  * Refactor INSTANTIATE_TEST_CASE_P -> INSTANTIATE_TEST_SUITE_P (#515 <https://github.com/ros-controls/ros2_control/issues/515>)
    Also removed the duplicated format & compiler fixes as on Galactic this shouldn't be an issue
  * rename get_current_state() to get_state() (#512 <https://github.com/ros-controls/ros2_control/issues/512>)
  * Fix spawner tests (#509 <https://github.com/ros-controls/ros2_control/issues/509>)
  * Removed deprecated CLI verbs (#420 <https://github.com/ros-controls/ros2_control/issues/420>)
  * Remove extensions from executable nodes (#453 <https://github.com/ros-controls/ros2_control/issues/453>)
  * Contributors: Bence Magyar, Denis Štogl, Dmitri Ignakov, Joseph Schornak, Márk Szitanics, Tim Clephas, bailaC, Mathias Aarbo

 -- karsten <karsten@osrfoundation.org>  Tue, 28 Sep 2021 23:00:00 -0000

ros-galactic-controller-manager (0.8.0-1focal) focal; urgency=high

  * Use clang format as code formatter (#491 <https://github.com/ros-controls/ros2_control/issues/491>)
  * Use example urdf from the test_assests package. (#495 <https://github.com/ros-controls/ros2_control/issues/495>)
  * Separate controller manager test cases (#476 <https://github.com/ros-controls/ros2_control/issues/476>)
  * Add Controller Manager docs (#467 <https://github.com/ros-controls/ros2_control/issues/467>)
  * sort interfaces in resource manager (#483 <https://github.com/ros-controls/ros2_control/issues/483>)
  * Add pre-commit setup. (#473 <https://github.com/ros-controls/ros2_control/issues/473>)
  * Make controller_manager set controller's use_sim_time param when use_sim_time=True (#468 <https://github.com/ros-controls/ros2_control/issues/468>)
    * potential solution to controller_manager use_sim_time sharing issue
    * removed debug print statements


=== debian/control ===
Source: ros-galactic-controller-manager
Section: misc
Priority: optional
Maintainer: karsten <karsten@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gmock, ros-galactic-ament-cmake-gtest, ros-galactic-ament-index-cpp, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-controller-interface, ros-galactic-controller-manager-msgs, ros-galactic-hardware-interface, ros-galactic-launch, ros-galactic-launch-ros, ros-galactic-pluginlib, ros-galactic-rclcpp, ros-galactic-rcpputils, ros-galactic-ros2-control-test-assets, ros-galactic-ros2param, ros-galactic-ros2run, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-controller-manager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-ament-index-cpp, ros-galactic-controller-interface, ros-galactic-controller-manager-msgs, ros-galactic-hardware-interface, ros-galactic-launch, ros-galactic-launch-ros, ros-galactic-pluginlib, ros-galactic-rclcpp, ros-galactic-rcpputils, ros-galactic-ros2-control-test-assets, ros-galactic-ros2param, ros-galactic-ros2run, ros-galactic-ros-workspace
Description: Description of controller_manager

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-controller-manager//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
